#!/bin/awk -f
#
# grind artists index from name-map and name-list.
#
# name-map comes first in the form:
#   canonical-name:human-readable-name
# examples:
#   artist:Artist Name
#   artist/album:Album Title
#   artist/album/song:Song Title
#
# then name-list in the form:
#   canonical-name
# examples:
#   artist
#   artist/album
#   artist/album/song.mp3
#

BEGIN {
    art=""
    narts=0
}

# old style tag file with just name
/^[^:]*:[^:=]*$/ {
    split($0,a,":")
    namemap[a[1]]=a[2]
}

/:N=/ {
    split($0,a,":")
    i=index($0,"=")
    namemap[a[1]]=substr($0,i+1)
}

/:T=/ {
    split($0,a,":")
    i=index($0,"=")
    timemap[a[1]]=substr($0,i+1)
}

/:BOLD=/ {
    split($0,a,":")
    i=index($0,"=")
    boldmap[a[1]]=substr($0,i+1)
}

!/:/ && (!/\./ || /\.mp3$/) {
    canon=$1
    names=$1
    if (names ~ /\.mp3$/) {
	names=substr(names, 1, length(names)-4)
    }
    nel=split(names,a,"/");
    aa[1]=a[1]
    for (i = 2; i <= nel; i++) {
	aa[i]=aa[i-1] "/" a[i]
    }
    name=a[nel]
    if (namemap[names] != "") {
	name=namemap[names];
    }
    if (art != a[nel-2]) {
	art = a[nel-2]
	if (namemap[aa[nel-2]] != "") {
	    b=namemap[aa[nel-2]]
	} else {
	    b=a[nel-2]
	}
	if (boldmap[aa[nel-2]] != 0) {
	    bold[narts] = 1
	} else {
	    bold[narts] = 0
	}
	arts[narts++]=b
    }
}

END {
    print "<center><b> - " narts " - </b></center><p>"
    nrows=int((narts + 2) / 3)
    print "<ul>"
    print "<table width=90%>"
    for (i = 0; i < nrows; i++) {
	print "<tr>"
	for (j = 0; j < nrows*3; j += nrows) {
	    k=j + i
	    if (k < narts) {
		b=arts[k]
		if (bold[k]) {
		    bb="<font size=+1><b>" b "</b></font>"
		} else {
		    bb=b
		}
		print "<td width=33%><a href=\"/rfm/tunes-byartist.html#" b "\">" bb "</td>"
	    }
	}
	print "</tr>"
    }
    print "</table>"
    print "</ul>"
}

